import axios, { isAxiosError } from 'axios';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var gauthUrl = 'https://server.gauth.co.kr';
var resourceUrl = 'https://open.gauth.co.kr';

var _a;
var errorMessages = (_a = {}, _a[gauthUrl] = {
  '/oauth/token': {
    POST: {
      400: 'clientSecret이 올바르지 않습니다',
      401: '토큰이 변질 또는 만료되었습니다',
      404: 'clientId가 올바르지 않습니다',
      '*': '서버에 문제가 발생했습니다\n관리자에게 문의해 주세요'
    },
    PATCH: {
      401: '토큰이 변질 또는 만료되었습니다',
      404: '토큰에 따른 유저를 찾지 못했습니다',
      '*': '서버에 문제가 발생했습니다\n관리자에게 문의해 주세요'
    }
  },
  '/oauth/code': {
    POST: {
      400: '비밀번호가 일치하지 않습니다',
      404: '이메일에 따른 유저를 찾지 못했습니다',
      '*': '서버에 문제가 발생했습니다\n관리자에게 문의해 주세요'
    }
  }
}, _a[resourceUrl] = {
  '/oauth/token': {
    GET: {
      400: 'clientSecret이 일치하지 않습니다',
      401: '토큰이 변질 또는 만료되었습니다',
      404: '등록된 서비스를 찾지 못했습니다',
      '*': '서버에 문제가 발생했습니다\n관리자에게 문의해 주세요'
    }
  }
}, _a);

var errorMapper = function errorMapper(url, method, status) {
  var Url = new URL(url);
  try {
    var messages = errorMessages[Url.origin][Url.pathname][method.toUpperCase()];
    return messages[status] ? messages[status] : messages['*'];
  } catch (e) {
    return '알 수 없는 에러가 발생했습니다';
  }
};

var gauthApi = axios.create({
  baseURL: gauthUrl
});
gauthApi.interceptors.response.use(function (res) {
  return res;
}, function (e) {
  var _a, _b;
  if (!isAxiosError(e) || !e.response) return Promise.reject(e);
  e.message = errorMapper("".concat(gauthUrl).concat((_a = e.config) === null || _a === void 0 ? void 0 : _a.url), ((_b = e.config) === null || _b === void 0 ? void 0 : _b.method) || '', e.response.status);
  return Promise.reject(e);
});

var resourceApi = axios.create({
  baseURL: resourceUrl
});
resourceApi.interceptors.response.use(function (res) {
  return res;
}, function (e) {
  var _a, _b;
  if (!isAxiosError(e) || !e.response) return Promise.reject(e);
  e.message = errorMapper("".concat(resourceUrl).concat((_a = e.config) === null || _a === void 0 ? void 0 : _a.url), ((_b = e.config) === null || _b === void 0 ? void 0 : _b.method) || '', e.response.status);
  return Promise.reject(e);
});

/**
 * code를 발급받습니다
 * @param {Request} data - IssueCodeRequest
 * @throws {AxiosError}
 * @returns {Response} - IssueCodeResponse
 */
var issueCode = function issueCode(data) {
  return __awaiter(void 0, void 0, void 0, function () {
    var prefix, body;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          prefix = '@gsm.hs.kr';
          return [4 /*yield*/, gauthApi({
            method: 'POST',
            url: '/oauth/code',
            data: __assign(__assign({}, data), {
              email: data.email.includes(prefix) ? data.email : "".concat(data.email).concat(prefix)
            })
          })];
        case 1:
          body = _a.sent().data;
          return [2 /*return*/, body];
      }
    });
  });
};

/**
 * code를 통해 토큰을 발급받을 수 있습니다
 * @param {Request} data - IssueTokenRequest
 * @throws {AxiosError}
 * @returns {Response} IssueTokenResponse
 */
var issueToken = function issueToken(data) {
  return __awaiter(void 0, void 0, void 0, function () {
    var body;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, gauthApi({
            method: 'POST',
            url: '/oauth/token',
            data: data
          })];
        case 1:
          body = _a.sent().data;
          return [2 /*return*/, body];
      }
    });
  });
};

/**
 * 토큰을 재발급합니다
 * @param {Request} data - ReissueTokenRequest
 * @throws {AxiosError}
 * @returns {Promise<Response>} - ReissueTokenResponse
 */
var reissueToken = function reissueToken(data) {
  return __awaiter(void 0, void 0, void 0, function () {
    var body;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, gauthApi({
            method: 'PATCH',
            url: '/oauth/token',
            withCredentials: true,
            headers: {
              Authorization: "Bearer ".concat(data.refreshToken)
            }
          })];
        case 1:
          body = _a.sent().data;
          return [2 /*return*/, body];
      }
    });
  });
};

/**
 * 유저 정보를 가져옵니다
 * @param {Request} data - GetUserRequest
 * @throws {AxiosError}
 * @returns {Response} - GetUserResponse
 */
var getUser = function getUser(data) {
  return __awaiter(void 0, void 0, void 0, function () {
    var body;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4 /*yield*/, resourceApi({
            method: 'GET',
            url: '/oauth/token',
            withCredentials: true,
            headers: {
              Authorization: "Bearer ".concat(data.accessToken)
            }
          })];
        case 1:
          body = _a.sent().data;
          return [2 /*return*/, body];
      }
    });
  });
};

var Gauth = {
  issueCode: issueCode,
  issueToken: issueToken,
  reissueToken: reissueToken,
  getUser: getUser
};

export { Gauth as default, getUser, issueCode, issueToken, reissueToken };
